require 'app.rb'
require 'test/unit'
require 'rack/test'

require 'json'

ENV['RACK_ENV'] = 'test'

class AppTest < Test::Unit::TestCase
  include Rack::Test::Methods

  def app
    Sinatra::Application
  end

  def test_index
    get '/'
    assert last_response.ok?
    assert_match /^text.html/, last_response.content_type
  end

  def test_gals
    # TODO Take advantage of environments.
    get '/gals/photos'
    assert last_response.ok?, "Nope, not ok to get /gals/test/pics"
    assert_match /^application.json/, last_response.content_type
    assert_nothing_raised(JSON::ParserError) { JSON.parse(last_response.body) }
    list = JSON.parse(last_response.body)
    # XXX Too much?
    %w{ id montage tw th gal   }.each{|k| assert list[0].has_key? k}
    %w{ id thumb w h tw th gal }.each{|k| assert list[-1].has_key? k}
  end

  def test_make_thumb
    # TODO Take advantage of environments.
    get '/make/thumb/photos/IMG_0470.JPG'

    assert last_response.ok?, "Nope, not ok to get /make/thumb/photos/IMG_0470.JPG"

    assert_match /^application.json/, last_response.content_type
    assert_nothing_raised(JSON::ParserError) { JSON.parse(last_response.body) }

    img = JSON.parse(last_response.body)
    # XXX Too much?
    %w{ id thumb w h tw th gal }.each{|k| assert img.has_key? k}
  end

  def test_make_montage
    # TODO Take advantage of environments.
    get '/make/montage/photos/morepics'

    assert last_response.ok?, "Nope, not ok to get /make/thumb/photos/morepics"

    assert_match /^application.json/, last_response.content_type
    assert_nothing_raised(JSON::ParserError) { JSON.parse(last_response.body) }

    dir = JSON.parse(last_response.body)
    # XXX Too much?
    %w{ id montage tw th gal   }.each{|k| assert dir.has_key? k}
  end
end
