require 'hh.rb'
require 'fileutils'
require 'test/unit'

class TestHaruHaru < Test::Unit::TestCase
  def setup
    FileUtils.rm_r 'test/pics/.thumbs' if File.directory?('test/pics/.thumbs')
  end

  def test_new
    assert_instance_of HaruHaru, HaruHaru.new('.'), "Failed to create HaruHaru"
  end
  def test_photo
    pic = HaruHaru.new('test/pics').photo('foo.jpg')
    assert_instance_of HaruHaru::Photo, pic, "Failed to create a HaruHaru::Photo"
    assert_equal 'test/pics/foo.jpg', pic.path
  end
  def test_photo_size
    pic = HaruHaru.new('test/pics').photo('foo.jpg')
    assert_equal [200, 200], pic.size, "Didn't get the expected size." 
    pic = HaruHaru::Image.new('test/pics/xxx.jpg')
    assert_equal [nil, nil], pic.size, "Didn't get the expected size." 
  end
  def test_photo_thumb
    pic = HaruHaru.new('test/pics').photo('foo.jpg')
    assert_equal 'test/pics/.thumbs/foo.jpg', pic.thumb.path, "Expected thumb path differs."
  end
  def test_photo_has_thumb
    pic = HaruHaru.new('test/pics').photo('foo.jpg')
    assert !pic.has_thumb?, "Has a thumb when there shouldn't be one"
  end
  def test_photo_make_thumb
    pic = HaruHaru.new('test/pics').photo('foo.jpg')
    assert !File.file?(pic.thumb.path)
    assert_equal pic.thumb.path, pic.make_thumb.path, "Expected thumb path differs."
    assert File.file?(pic.thumb.path)
  end
  def test_gallery
    hh = HaruHaru.new('test/pics')
    assert_equal %w{test/pics/morepics test/pics/nopics test/pics/foo.jpg},
                 hh.gallery.listing.collect{|f| f.path}
  end
  def test_gallery_make_montage
    hh = HaruHaru.new('test/pics')
    assert_nothing_raised(Exception) { hh.gallery.make_montage }
    assert hh.gallery.has_montage?, "Montage wasn't created for some reason."
    assert_nil HaruHaru.new('test/pics/nopics').gallery.make_montage
  end

#  def test_montage
#    mon = HaruHaru.new('test/pics').montage(%w{foo.jpg bar.jpg baz.jpg})
#    assert_instance_of HaruHaru::Montage, mon, "Failed to create a HaruHaru::Montage"
#  end
#  def test_gallery
#    hh = HaruHaru.new('pics')
#    hh.gallery()
#  end
end
